
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <sstream>
#include <math.h>
#include "System.h"
#include "Utility.h"
#include "SNPData.h"
#include "Simulate.h"
#include "RelationshipUtils.h"
int Main(vector<string> args){
	SNPProfile profile;
	SNPData data;
	  cerr << "Reading data..." << endl;
	ReadBinSNPProfileData("/bluebox/home/dkashef/Research/hapmap3_files/CEU_TSI_Train/hapmap3_CEU_TSI_Train.snpprofiledata.bin",profile, data);
	cerr << "data is read" << endl;
	int numInitialIndiv = data.num_diplos;
	Simulate::Diplo indivA, indivB;
	int numMRCAs, genA, genB, repeats, start;
	stringstream ss(args[1]); ss >> numMRCAs;

	ss.clear(); ss.str(args[2]); ss >> genA;

	ss.clear(); ss.str(args[3]); ss >> genB;
	ss.clear(); ss.str(args[4]); ss >> repeats;
	const char* prefilename = args[5].c_str();
	ss.clear(); ss.str(args[6]); ss >> start;
	srand(time(0));
	for(int i=0; i<repeats; i++)
	  {
	    cerr << "creating individuals: " << i << endl;
	    createRelatives(profile, data, indivA, indivB, numMRCAs, genA, genB, numInitialIndiv, false, false);
	    stringstream itr; itr<<(i+start);
	    string filename (prefilename);
	    filename = filename + itr.str();
	    ofstream outfile(filename.c_str());
	    cerr << "storing individuals" << endl;
	    storeIndividual(indivA, 0.0, "indivA",outfile);
	    cerr << "storing individuals" << endl;
	    storeIndividual(indivB, 0.0, "indivB",outfile);
	    outfile.close();
	    
	    
	    /*
	      cerr << "Individual A" << endl;
	      cerr << "Pop:" << indivA.pop << endl;

	      printDiploSegments(indivA);

	      cerr << "Individual B " << endl;
	      cerr << "Pop:" << indivB.pop << endl;

	      printDiploSegments(indivB);
	      
	      ifstream infile(filename.c_str());
	      Simulate::Diplo restoredA, restoredB;
	      restoreIndividual(data, restoredA, infile);
	      restoreIndividual(data, restoredB, infile);
	      infile.close();
	      
	      cerr << "restored Individual A" << endl;
	      cerr << "Pop:" << restoredA.pop << endl;

	      printDiploSegments(restoredA);

	      cerr << "Restored Individual B " << endl;
	      cerr << "Pop:" << restoredB.pop << endl;

	      printDiploSegments(restoredB); */
	    
	    
	  }  
	  
}
