clear all

% outDir = 'plots/postcountsHist/aggregated/';
% 

assumedRel = '2_1_1';

% assumedRelStr = strrep(assumedRel, '_', ',');
% outfilename = strcat(outDir, 'postcounts_hist_assumed_', ...
%     assumedRel, '.txt');
% outfile = fopen(outfilename, 'w');
% fprintf(outfile, 'rel\tmeanA\tstdA\tmeanB\tstdB\n');

numCounts = 4;
% 
% countsAll = [];
% 
% meanFreq = zeros(5, 1);
% stdFreq = zeros(5, 1);
% 
% for dist = 0:4,
%     counts = [];
%     for d = 1:5,
%         filename = strcat('matFiles/newIbdNewPost/set1_indiv1to100_', int2str(d), 'd_all_vs_3d.mat');
%         dataStruct = load(filename);
%         trueRels = dataStruct.trueRels;
%         for r1 = 1:length(dataStruct.assumedRels),
%             if strcmp(dataStruct.assumedRels{r1}, assumedRel)
%                 selectAssumedRel = r1;
%             end
%         end
%         
%         for r = 1:length(trueRels),
%             [mrcaStr, genAstr, genBstr] = strread(trueRels{r}, '%s %s %s', 'delimiter', '_');
%             genA = str2num(char(strrep(genAstr, 'n', '-')));
%             genB = str2num(char(strrep(genBstr, 'n', '-')));
%             if genB - genA == dist,
%                 dataFlat = zeros(dataStruct.maxIndiv, 2);
%                 dataFlat(:, :) = dataStruct.data(r, :, (selectAssumedRel - 1) * numCounts + [2:3]);
%                 
%                 % Normalize
%                 dataNorms = dataFlat(:, 1) + dataFlat(:, 2);
%                 dataFlat(:, 1) = dataFlat(:, 1) ./ dataNorms;
%                 dataFlat(:, 2) = dataFlat(:, 2) ./ dataNorms;
%                 
%                 counts = [counts; dataFlat(:, 1)];
%             end
%         end
%     end
%     if length(counts) >= 300,
%         countsAll = [countsAll, counts(randsample(1:length(counts), 300))];
%     end
%     h = figure();
%     hist(counts);
%     %axis([0.0 1.0 0 30]);
%     title(['Dist ', int2str(dist), ...
%         ', assumed rel ', assumedRelStr]);
%     legend('freq A < freq B');%, ' freq A > freq B');
%     meanFreq(dist + 1) = mean(counts);
%     stdFreq(dist + 1) = std(counts);
%     fprintf('%d\t%.2f\t%.2f\n', dist, meanFreq(dist + 1), stdFreq(dist + 1));
%     figFilename = strcat(outDir, 'postcounts_hist_dist', ...
%         int2str(dist), '_vs_', dataStruct.assumedRels{selectAssumedRel}, '.fig');
%     saveas(h, figFilename);
%     fprintf(outfile, '%d\t%.2f\t%.2f\n', dist, meanFreq(dist + 1), stdFreq(dist + 1));
%                 
% end
% figure();
% [n, xout] = hist(countsAll);
% bar(xout, n / 300, 'hist');
% legend('dist 0', 'dist 1', 'dist 2', 'dist 3');
% hold on;
% figure();
% colors = {'b', 'r', 'g', 'm', 'c'};
% xpoints = 0:0.01:1;
% for dist = 0:3,
%     p = line(xpoints, normpdf(xpoints, meanFreq(dist + 1), stdFreq(dist + 1)));
%     set(p, 'Color', colors{dist + 1});
%     hold on;
% end
% hold off;
% legend('dist 0', 'dist 1', 'dist 2', 'dist 3', 'dist 4');

plotClasses = {'2_1_1', '2_0_2'};

numIndivPerSet = [100, 0, 0, 100];
likelihoods = zeros(sum(numIndivPerSet), length(plotClasses));

for d = 3,
    filenames = {strcat('matFiles/newIbdNewPost/set1_indiv1to100_', ...
        int2str(d), 'd_all_vs_3d.mat'), strcat('matFiles/newIbdNewPost/set4_indiv1to100_', ...
        int2str(d), 'd_all_vs_3d.mat')};
    dataStruct = load(filenames{1});
    trueRels = dataStruct.trueRels;
    assumedRels = dataStruct.assumedRels;
    data = loadClassifierData(filenames, trueRels, assumedRels, numIndivPerSet);
    
    for r1 = 1:length(assumedRels),
        if strcmp(assumedRels{r1}, assumedRel)
            selectAssumedRel = r1;
        end
    end
    
    for r = 1:length(trueRels),
        for r1 = 1:length(plotClasses),
            if strcmp(trueRels{r}, plotClasses{r1})
                dataNorms = data(r, :, (selectAssumedRel - 1) * numCounts + 2) + data(r, :, (selectAssumedRel - 1) * numCounts + 3);
                likelihoods(:, r1) = data(r, :, (selectAssumedRel - 1) * numCounts + 2) ./ dataNorms;
            end
        end
    end
    for r = 1:length(plotClasses),
        plotClassNames{r} = strrep(strrep(plotClasses{r}, '_', ','), 'n', '-');
    end
    hist(likelihoods, 10);
    colormap jet;
    set(gca, 'FontSize', 14);
    xlim([0.2 0.8]);
    
    pyLabel = ylabel('Frequency');
    pxLabel = xlabel({'', 'Percentage of IBD transitions where \it{C_A < C_B}', ''});
    legend(plotClassNames);
    set([pxLabel, pyLabel], 'FontSize', 16);
    
    set(gca, ...
        'ActivePositionProperty', 'outerposition', ...
        'Box'         , 'off'     , ...
        'TickDir'     , 'out'     , ...
        'TickLength'  , [.02 .02] , ...
        'XMinorTick'  , 'off'      , ...
        'YMinorTick'  , 'off'      , ...
        'LineWidth'   , 1         );
    
    %figure();
    %for c = 1:size(likelihoods, 2),
    %    hist(likelihoods(:, c), 10);
    %    hold on;
    %end
    %axis([0.2 0.8 0 30]);
    %hold off;
end
%     for r = 1:length(trueRels),
%         [mrcaStr, genAstr, genBstr] = strread(trueRels{r}, '%s %s %s', 'delimiter', '_');
%         genA = str2num(char(strrep(genAstr, 'n', '-')));
%         genB = str2num(char(strrep(genBstr, 'n', '-')));
%         if genA <= genB,
%             dataFlat = zeros(dataStruct.maxIndiv, 2);
%             dataFlat(:, :) = dataStruct.data(r, :, (selectAssumedRel - 1) * numCounts + [2:3]);
%             
%             % Normalize
%             dataNorms = dataFlat(:, 1) + dataFlat(:, 2);
%             dataFlat(:, 1) = dataFlat(:, 1) ./ dataNorms;
%             dataFlat(:, 2) = dataFlat(:, 2) ./ dataNorms;
%             
%             h = figure();
%             hist(dataFlat(:, 1), 8);
%             axis([0.0 1.0 0 30]);
%             title(['True rel ', strrep(trueRels{r}, '_', ','), ...
%                 ', assumed rel ', assumedRelStr]);
%             legend('freq A < freq B');%, ' freq A > freq B');
%             meanFreq = mean(dataFlat, 1);
%             stdFreq = std(dataFlat, 1); 
%             fprintf('%s\t%.2f\t%.2f\t%.2f\t%.2f\n', trueRels{r}, meanFreq(1), ...
%                 stdFreq(1), meanFreq(2), stdFreq(2));
%             figFilename = strcat(outDir, 'postcounts_hist_', trueRels{r}, ...
%                 '_vs_', dataStruct.assumedRels{selectAssumedRel}, '.fig');
%             saveas(h, figFilename);
%             fprintf(outfile, '%s\t%.2f\t%.2f\t%.2f\t%.2f\n', trueRels{r}, meanFreq(1), ...
%                 stdFreq(1), meanFreq(2), stdFreq(2));
% 
%         end
%     end
% end
% fclose(outfile);