% Visualize true IBD, posterior IBD and transitions in postcounts.
trueIBDpref = '../TrueIBD/hapmap3_CEU_TSI_phaseErr008/CEU_TSI_Set_1/Pair_';
postIBDPref = '../Likelihoods/hapmap3_CEU_TSI/CEU_TSI_Set_1/Pair_';
%countsPref = '../PostCounts/hapmap3_CEU_TSI_cleared/Pair_';
%distPref = '../BlockGeneticDist/hapmap3_CEU/Pruned/Pair_';

close all

rel = '1_n1_0';
iCutoff = 0.9;
chr = 10;

% dists = importdata(strcat(distPref, rel, '/Pair_', rel, '_chr', ...
%     int2str(chr), '_Merged_10000'));
% minDist = prctile(dists, 5);

chrCol = 4;
startCol = 5;
endCol = 6;
startGenetPos = 11;
endGenetPos = 12;

for i = 1:1,
%     trueIBD = importdata(strcat(trueIBDpref, rel, ...
%         '/CEU_TSI_Set_1_Pair_', rel, '_', int2str(i), ...
%         '/CEU_TSI_Set_1_Pair_', rel, '_', int2str(i), '_chr', ...
%         int2str(chr), '_pruned.trueibd'));
    postIBDtemp = importdata(strcat(postIBDPref, rel, ...
        '/CEU_TSI_Set_1_Pair_', rel, '_', int2str(i), ...
        '/CEU_TSI_Set_1_Pair_', rel, '_', int2str(i), '_chr', ...
        int2str(chr), '_pruned_2_0_1.postibd'));
%     postIBDtemp = importdata('../Likelihoods/hapmap3_CEU_TSI/CEU_TSI_Set_2/Trees/Tree_2_4_4/Tree_2_4_4_1/indiv0_indiv9/Tree_2_4_4_1_indiv_0_indiv_9chr17_pruned_1_1_1.postibd');
%     countsTemp = importdata(strcat(countsPref, rel, ...
%         '/CEU_Pair_', rel, '_', int2str(i), ...
%         '/CEU_Pair_', rel, '_', int2str(i), '_w20_i0.9_n0.6_c0.5_2_1_2.postcounts'));
%     countsData = countsTemp.data(countsTemp.data(:, chrCol) == chr, :);
%     
%     % countIBD will be the IBD vector based on the transitions in
%     % postcounts
%     countIBD = zeros(size(trueIBD, 1), 1);
%     % First transition is 1->0, so we call all the SNPs up to the
%     % transition IBD.
%     if ~isempty(countsData) && countsData(1, 1) == 1 && ...
%             countsData(1, endGenetPos) - countsData(1, startGenetPos) > minDist,
%         % convert from 0-based to 1-based
%         countIBD(1:countsData(1, endCol)) = 1;
%     end
%     for j = 1:size(countsData, 1),
%         if countsData(j, 1) == 1 && countsData(j, 2) == 0 && ...
%                 countsData(j, endGenetPos) - countsData(j, startGenetPos) > minDist,
%             countIBD((countsData(j, startCol) + 1):countsData(j, endCol)) = 1;
%         end
%     end
%     countsSize = size(countsData, 1);
%     % Last transition is to IBD, so we call IBD all the SNPs from the
%     % transition to the last SNP.
%     if countsSize > 0 && countsData(countsSize, 2) == 1 && ...
%                 countsData(countsSize, endGenetPos) - countsData(countsSize, startGenetPos) > minDist,
%         countIBD((countsData(countsSize, endCol) + 1):length(countIBD)) = 1;
%     end
%     
%     % Plot true IBD blocks.
%     figure();
%     subplot(3, 1, 1);
%     area(trueIBD(:, 1));
%     
%     % Plot an IBD block wherever the posterior prob of IBD > iCutoff.
%     postIBD = exp(postIBDtemp);
%     discPostIBD = zeros(size(postIBD, 1), 1);
%     discPostIBD(postIBD(:, 1) > iCutoff) = 1;
%     subplot(3, 1, 2);
%     area(discPostIBD(:, 1));
    
%     % Plot the IBD blocks defined from the transitions in postcounts.
%     subplot(3, 1, 3);
%     area(countIBD(:, 1));

    postIBD = exp(postIBDtemp);
    for j = 1:5,
        figure();
        plot(postIBD(:, j));
    end
    postCols = [1, 4, 5];
    figure();
%     subplot(4, 1, 1);
%     area(trueIBD(:, 1));
    subplot(4, 1, 2);
    plot(postIBD(:, 1));
    subplot(4, 1, 3);
    plot(postIBD(:, 2));
    subplot(4, 1, 4);
    plot(postIBD(:, 3));    
    for j = 2:3,
        figure();
%         subplot(2, 1, 1);
%         area(trueIBD(:, j));
        subplot(2, 1, 2);
        plot(postIBD(:, postCols(j)));
    end
end

% binPref = '/media/5F9D8A624624BE1D/Shared/hapmap/hapmap3/CEU/hapmap3_CEU_Pruned_chrom';
% individualDir = '/media/5F9D8A624624BE1D/Shared/RelationshipInfer/Individuals/hapmap3_CEU_Individuals_NEW/';
% likelihoodDir = '/media/5F9D8A624624BE1D/Shared/RelationshipInfer/Likelihoods/hapmap3_CEU/';
% cppDir = '/media/5F9D8A624624BE1D/Shared/RelationshipInfer/src/';
% 
% rel = '1_0_0';
% minIndiv = 1;
% maxIndiv = 1;
% minChr = 19;
% maxChr = 19;
% numRels = 17;
% 
% ibdErrors = zeros(length(minIndiv:maxIndiv), numRels);
% corrAErrors = zeros(length(minIndiv:maxIndiv), numRels);
% corrBErrors = zeros(length(minIndiv:maxIndiv), numRels);
% 
% numIndiv = 0;
% numSNPs = 0;
% for i = minIndiv:maxIndiv,
%     numIndiv = numIndiv + 1;
%     for c = minChr:maxChr,
%         pairName = strcat('Pair_', rel);
%         indivName = strcat(pairName, '_', num2str(i));
%         filePref = strcat(likelihoodDir, pairName, '/CEU_', indivName, ...
%             '/CEU_', indivName, '_chr', num2str(c), '_pruned');
%         pairFile = strcat(individualDir, pairName, '/CEU_', indivName, ...
%             '/CEU_', indivName, '_chrom', num2str(c), '_pruned');
%         binFile = strcat(binPref, num2str(c), '.snpprofiledata.bin');
%         ibdFile = strcat(pairFile, '.ibd');
%         
%         command = [cppDir, 'ComputeTrueIBDMain ', binFile, ' ', ...
%             pairFile, ' ', ibdFile];
%         [status, result] = system(command);
%         %   binFile pairFile ibdFile
%         %[status, result] = system([strcat(cppDir, 'ComputeTrueIBDMain ') ...
%         %   binFile pairFile ibdFile]);
%         trueIBD = importdata(ibdFile, '\t');
%         seqProbs = importdata(strcat(filePref,'.logProb'), '\t', 3);
%         
%         seqProbs.colheaders{1} = strrep(seqProbs.colheaders{1}, '#', '');
%         rels = seqProbs.colheaders;
%         for r = 1:length(rels),
%             if findstr(rels{i}, 'unrel'),
%                 continue;
%             end
%             relPref = strcat(filePref, '_', rels{i});
%             forward = importdata(strcat(relPref, '.for'), '\t', 1);
%             backward = importdata(strcat(relPref, '.back'), '\t', 1);
%             posteriorUnnorm = forward + backward;
%             
%             if i == minIndiv && c == minChr && r == 1,
%                 numSNPs = numSNPs + size(forward, 1);
%             end
%             states = forward.colheaders;
%             states{1} = strrep(states{1}, '#', '');
%             correlation = zeros(length(states), 3);
%             for s = 1:length(states),
%                 parts = regexp(rels{i}, '_', 'split');
%                 mrcas = str2double(parts(1));
%                 genA = -1;
%                 if ~findstr(parts(2), 'n'),
%                     genA = str2double(parts(2));
%                 end
%                 if ~findstr(parts(3), 'n'),
%                     genB = str2double(parts(3));
%                 end
%                 if mrcas == 2,
%                     correlation(s, :) = getCorrelation2MRCA(states{s}, genA, genB);
%                 else
%                     correlation(s, :) = getCorrelation1MRCA(states{s}, genA, genB);
%                 end
%             end
%                         
%             corr1 = find(correlation(:, 1) == 1);
%             corr2 = find(correlation(:, 1) == 2);
%             corrA = find(correlation(:, 2));
%             corrB = find(correlation(:, 3));
%             
%             for j = 1:size(forward, 1),
%                 pred = exp(computeLogSum(posteriorUnnorm(j, corr1)) - ...
%                     seqProbs(1, r)) + ...
%                     2 * exp(computeLogSum(posteriorUnnorm(j, corr2)) - ...
%                     seqProb(1, r));
%                 diff = trueIBD(j, 1) - pred;
%                 ibdErrors(numIndiv, r) = ibdErrors(numIndiv, r) + diff * diff;
%                 
%                 pred = exp(computeLogSum(posteriorUnnorm(j, corrA)) - ...
%                     seqProbs(1, r));
%                 diff = trueIBD(j, 2) - pred;
%                 corrAErrors(numIndiv, r) = corrAErrors(numIndiv, r) + diff * diff;
%                 
%                 pred = exp(computeLogSum(posteriorUnnorm(j, corrB)) - ...
%                     seqProbs(1, r));
%                 diff = trueIBD(j, 2) - pred;
%                 corrBErrors(numIndiv, r) = corrBErrors(numIndiv, r) + diff * diff;
%             end
%         end
%     end
% end
% 
% ibdErrors = ibdErrors / numSNPs
% corrAErrors = corrAErrors / numSNPs
% corrBErrors = corrBErrors / numSNPs