clear all
dir = 'matFiles/newIbd/';
pref = 'set1_indiv1to50_';
trueRelStr = '5d';
filenames = {};

extraPref = '_all';
if strcmp(trueRelStr, 'unrel'),
    extraPref = '';
end
for i = 1:5,
    if strcmp(trueRelStr, [int2str(i), 'd']) || i == 1,
        filenames = [filenames, [dir, pref, trueRelStr, extraPref, '_vs_', int2str(i), 'd', '.mat']];
    else
        filenames = [filenames, [dir, pref, trueRelStr, extraPref, '_vs_', int2str(i), 'da', '.mat']];
    end
end
filenames = [filenames, [dir, pref, trueRelStr, extraPref, '_vs_unrel', '.mat']];

degreeRels = degreeClassificationRels();%{'2_0_0', '1_n1_0', '1_0_n1', '2_0_1', '2_1_0', '2_1_1', '2_1_2', '2_2_2'};%, 'unrel'};

restored = load(char(filenames{1}));
set = restored.set;
minIndiv = restored.minIndiv;
maxIndiv = restored.maxIndiv;
trueRels = restored.trueRels;

newFilename = strcat(dir, pref, trueRelStr, '_degree.mat');
degreeData = loadClassifierData(filenames, trueRels, degreeRels, maxIndiv);
saveClassifierData(newFilename, trueRels, degreeRels, set, minIndiv, maxIndiv, degreeData);