% cutoffs(r, c) is the "percent" percentile of genetic sizes for the r-th
% relationship in rels and chromosome c.
function cutoffs = loadCutoffs(distPref, rels, percent)
cutoffs = zeros(length(rels), 22);
for r = 1:length(rels),
    for c = 1:22,
        dists = importdata(strcat(distPref, rels{r}, '/Pair_', rels{r}, ...
            '_chr', int2str(c), '_Merged_10000'));
        cutoffs(r, c) = prctile(dists, percent);
    end
end
end