OBJEXT = .o
CPPEXT = .cpp
HDREXT = .h

COMPILE = g++ -c
COMPILE_FLAGS_DEBUG = -g
#COMPILE_FLAGS_OPTIMIZE = -O4 -march=pentium4 -mmmx -msse -msse2 -mfpmath=sse -m32
COMPILE_FLAGS_OPTIMIZE = -O4 -march=nocona
#COMPILE_FLAGS = -Iinc -DGD -DCAIRO -I/usr/include/cairo
#My flags
COMPILE_FLAGS =

ifdef DEBUG
COMPILE_FLAGS += $(COMPILE_FLAGS_DEBUG)
else
COMPILE_FLAGS += $(COMPILE_FLAGS_OPTIMIZE)
endif

ifdef PROFILE
COMPILE_FLAGS += -pg -g
endif

LINK = g++ -o
LINK_FLAGS_DEBUG = -g
LINK_FLAGS_OPTIMIZE = -O4 -march=nocona
#LINK_FLAGS = -lm -lbz2 -lgd -DGD -lcairo -DCAIRO -I/usr/include/cairo
#My flags
LINK_FLAGS = -lbz2 -lgd

ifdef DEBUG
LINK_FLAGS += $(LINK_FLAGS_DEBUG)
else
LINK_FLAGS += $(LINK_FLAGS_OPTIMIZE)
endif

ifdef PROFILE
LINK_FLAGS += -pg -g
endif

REMOVE = rm -f
REMOVE_RECURSIVE = rm -rf

COPY = cp

MAKE = make -C

CHDIR = cd

